# Fetching a list of Timesheet Submissions

This endpoint returns structured Timesheet Submission objects.
As with all Kantata OX API endpoints, the returned data will be referenced in sorted order in the results array
and will be indexed by ID in the timesheet_submissions top-level JSON key.
Please see our Response Format section for more information.

Endpoint: GET /timesheet_submissions
Version: 1.0.0

## Query parameters:

  - `active` (boolean)
    Returns only active submissions.

  - `created_after` (string)
    Filter for records created after a specified datetime. The datetime must be in ISO 8601 format.

  - `created_before` (string)
    Filter for records created before a specified datetime. The datetime must be in ISO 8601 format.

  - `end_date` (string)
    Limit Timesheet Submissions to the week ending with this date. The date must be in ISO 8601 format.

  - `external_reference_external_message` (string)
    Filter the objects based on the external message of their associated external references. This is an exact match.

  - `external_reference_external_status` (string)
    Filter by the status of the external object in the external system.

  - `external_reference_service_model` (string)
    Filter by the type of the external object this external reference belongs to.

  - `external_reference_service_model_ref` (integer)
    Filter by the id of the external object this external reference belongs to.

  - `external_reference_service_model_refs` (string)
    Filter for objects that correlate to the specified external object IDs. Provide a comma-separated list of up to 200 external IDs.

  - `external_reference_service_name` (string)
    Filter by the name of the provider for integration.

  - `external_reference_status` (string)
    Filter by the status of the integration, this can be successful or fail.

  - `has_external_references` (boolean)
    Filter by whether or not the object has external references.

  - `include` (string)
    Any of the below associations can be included in your request by providing the include param, e.g. include=association1,association2.
- external_references (ExternalReference) - Includes references to external integrations for this object.
- time_entries (TimeEntry) - Reference the Time Entries that belong to the Timesheet Submissions.
- user (User) - Includes user who owns the line items on the submission.
- workspace (Workspace) - Includes workspace to which the submission belongs.

  - `not_cancelled` (boolean)
    Returns only submissions that are not cancelled.

  - `only` (string)
    Allows you to request one or more resources directly by ID. Multiple IDs can be supplied
in a comma separated list, like GET /api/v1/workspaces.json?only=5,6,7.

  - `order` (string)
    Supply order with the name of a valid sort field for the endpoint and a direction.

Valid values: date:asc and date:desc.

  - `page` (integer)

  - `per_page` (integer)

  - `start_date` (string)
    Limit Timesheet Submissions to the week starting with this date. The date must be in ISO 8601 format.

  - `start_date_after` (string)
    Filter for Timesheet Submissions that start on OR after a specified datetime. The date must be in ISO 8601 format.

  - `statuses` (string)
    Returns submissions with the statuses specified. Multiple statuses can be supplied in a comma separated list.
Valid values: ‘new’, ‘cancelled’, ‘rejected’, and ‘approved’.

  - `updated_after` (string)
    Filter for records updated after a specified datetime. The datetime must be in ISO 8601 format.

  - `updated_before` (string)
    Filter for records updated before a specified datetime. The datetime must be in ISO 8601 format.

  - `user_ids` (string)
    Only includes submissions associated with the specified user ids.

  - `without_external_reference_service_name` (string)
    Exclude by the existence of an external reference with the specified service name.

  - `workspace_id` (integer)
    Ordered by the submission's workspace id.

  - `workspace_ids` (string)
    Only includes submissions associated with the specified workspace ids.

## Response 200 fields (application/json):

  - `count` (integer)

  - `meta` (object)

  - `meta.count` (integer)

  - `meta.page_count` (integer)

  - `meta.page_number` (integer)

  - `meta.page_size` (integer)

  - `results` (array)

  - `results.key` (string)

  - `results.id` (string)

  - `timesheet_submissions` (object)

  - `external_references` (object)

  - `users` (object)

  - `workspaces` (object)

  - `time_entries` (object)

## Response 400 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 401 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 403 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 404 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 422 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)

## Response 503 fields (application/json):

  - `errors` (array)

  - `errors.type` (string)

  - `errors.message` (string)


